1  REM INTERMODULATION DISTORTION PROGRAM BASED ON ORIGINAL POROGRAM
2  REM BY A. KATZ.  WRITTEN BY H. CHARLES ROSS FOR USE IN COMMUNICATIONS
3  REM SYSTEMS
4  REM CALCULATES EACH FREQUENCY PRODUCED AND THAT FREQUENCY's amplitude.
5  REM
6  REM
7  REM
8  REM
9  REM
100  GOSUB 910 :REM CLEAR SCREEN
110  PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT"            Intermodulation Product Calculation":PRINT:PRINT:PRINT:PRINT
120  PRINT"            for up to fifth order functions":PRINT:PRINT:PRINT
125  PRINT:PRINT:PRINT:PRINT"                                            BY: H. Charles Ross Jr.":PRINT:PRINT,"via k2uyh/wa2tif":PRINT
130  GOSUB 1130:REM DELAY
140  DIM X(30),H(30)
150  GOSUB 910 :REM CLEAR SCREEN
160  INPUT"Non-linear Coefficients A1, A2, A3, A4, A5 ";A1,A2,A3,A4,A5
170  INPUT"Frequency F1 and F2";F1,F2
180  INPUT"Amplitudes V1 and V2";V1,V2
190  INPUT"Do you want hard copy ";DV$
200  DV=0
210  IF LEFT$(DV$,1)="Y" OR LEFT$(DV$,1)="y" THEN DV=2
220  GOSUB 910 :REM CLEAR SCREEN
230  PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT"          T H I N K I N G"
240  X(1)=F1 :X(2)=F2 :X(3)=2*F1 :X(4)=2*F2
250  X(5)=3*F1 :X(6)=3*F2 :X(7)=4*F1 :X(8)=4*F2
260  X(9)=5*F1 :X(10)=5*F2 :X(11)=F1+F2 :X(12)=ABS(F1-F2)
270  X(13)=2*F1+F2 :X(14)=ABS(F2-(2*F1)) :X(15)=2*F2+F1 :X(16)=ABS(F1-(2*F2))
280  X(17)=3*F1+F2 :X(18)=ABS(F2-(3*F1)) :X(19)=ABS((2*F2)-(2*F1)) :X(20)=(2*F1)+(2*F2)
290  X(21)=ABS(F1-(3*F2)) :X(22)=3*F2+F1 :X(23)=ABS((3*F1)-(2*F2)) :X(24)=(3*F1)+(2*F2)
300  X(25)=ABS(F2-(4*F1)) :X(26)=4*F1+F2 :X(27)=ABS((3*F2)-(2*F1)) :X(28)=(3*F2)+(2*F1)
310  X(29)=ABS(F1-(4*F2)) :X(30)=4*F2+F1
320  REM CALCULATE THE AMPLITUDES ....
330  FOR K=1 TO 30
340  ON K GOSUB 930,940,950,960,970,980,990,1000,1010,1020,1030,1040,1040,1050,1050,1060,1060,1080,1080,1070,1070,1090,1090,1110,1110,1100,1100,1120,1120
350  H(K)=G
360  NEXT K
370  REM INPUT FREQUENCYS AND AMPLITUDES IN ORDER OF FREQUENCY
380  MV=5*(F1+F2):REM THIS IS TO NOT PRINT FREQ's with 0 amp., but I don't use it.
390  FOR J=1 TO 30
400  FOR I=J TO 30
410  IF X(I)<X(J) THEN GOSUB 450 :REM SWITCH
420  NEXT I
430  NEXT J
440  GOTO 490 :REM CONTINUE
450  REM SWITCH ROUTINE
460  Q=X(I)   :X(I)=X(J)   :X(J)=Q
470  Q=H(I)   :H(I)=H(J)   :H(J)=Q
480  RETURN
490  IF DV=2 THEN 750
500  REM SCREEN PRINT ROUTINE
510  GOSUB 910 :REM CLEAR SCREEN
520  GOSUB 840 :REM PRINT HEADING
530  PRINT:FOR I=1 TO 15
540  PRINTI;")          Frequency = ";X(I),"Amplitude = ";H(I)
550  NEXT I
560  PRINT:PRINT:INPUT"Press RETURN to continue -->  ";DV$
565  GOSUB 910 :REM CLEAR SCREEN
570  GOSUB 840 :REM PRINT HEADING
580  PRINT:FOR I=16 TO 30
590  PRINTI;")          Frequency = ";X(I),"Amplitude = ";H(I)
600  NEXT I
610  PRINT:PRINT:INPUT"Press RETURN to continue -->  ";DV$
620  GOSUB 910 :REM CLEAR SCREEN
630  PRINT:PRINT:PRINT:INPUT"Do you want to continue";DV$
640  IF LEFT$(DV$,1)<>"Y" AND LEFT$(DV$,1)<>"y" THEN PRINTCHR$(26):END
650  GOSUB 910 :REM CLEAR SCREEN
660  PRINT:PRINT:PRINT:INPUT"Do you want to change (ALL,AMP,FREQ,COEF,NONE) ";DV$
670  IF DV$="ALL" THEN 150 ELSE IF DV$="NONE" THEN 1160
680  IF DV$<>"AMP" THEN 700
690  INPUT"Amplitude V1 and V2 ";V1,V2  : GOTO 190
700  IF DV$<>"COEF" THEN 720
710  INPUT "Coefficients A1, A2, A3, A4, A5 ";A1,A2,A3,A4,A5  : GOTO 190
720  IF DV$<>"FREQ" THEN 620
730  INPUT "Frequencies F1 and F2";F1,F2
740  GOTO 190
750  REM HARD COPY ROUTINE
760  GOSUB 910 :REM CLEAR SCREEN
770  PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT:PRINT"       P r i n t i n g":PRINT:PRINT:PRINT:PRINT:PRINT
775  LPRINT,CHR$(12) :REM FORM FEED
780  GOSUB 840 :REM PRINT HEADING
790  FOR I=1 TO 30
800  LPRINT,I;")          Frequency = ";X(I),"Amplitude = ";H(I)
810  NEXT I
820  LPRINT,CHR$(12) :REM FORM FEED
830  GOTO 620
840  REM PRINT HEADING
850  LPRINT DV,:LPRINT DV,:LPRINT DV,:LPRINT DV,
860  LPRINT DV,"Intermodulation Products":LPRINT DV,
870  LPRINT DV,"Frequencies = ";F1;" and ";F2
880  LPRINT DV,"Amplitudes  = ";V1;" and ";V2
890  LPRINT DV,"Coefficients= ";A1;", ";A2;", ";A3;", ";A4;", and ";A5
900  RETURN
910  REM  CLEAR SCREEN ROUTINE
920  PRINTCHR$(26):RETURN
930  G=(A1*V1)+(3*A3*V1^3/4)+(3*A3*V1*V2^2/2)+(5*A5*V1^5/8)+(3*A5*V2^2*V1^3/2)+(9*A5*V1*V2^4/8):RETURN
940  G=(A1*V2)+(3*A3*V2^3/4)+(3*A3*V2*V1^2/2)+(5*A5*V2^5/8)+(3*A5*V1^2*V2^3/2)+(9*A5*V2*V1^4/8):RETURN
950  G=(A2*V1^2/2)+(A4*V1^4/2)+(A4*V1^2*V2^2/2):RETURN
960  G=(A2*V2^2/2)+(A4*V2^4/2)+(A4*V1^2*V2^2/2):RETURN
970  G=(A3*V1^3/4)+(5*A5*V1^5/16)+(A5*V2^2*V1^3/2):RETURN
980  G=(A3*V2^3/4)+(5*A5*V2^5/16)+(A5*V1^2*V2^3/2):RETURN
990  G=A4*V1^4/8:RETURN
1000  G=A4*V2^4/8:RETURN
1010  G=A5*V1^5/16:RETURN
1020  G=A5*V2^5/16:RETURN
1030  G=(A2*V1*V2)+(3*A4*V2*V1^3/4)+(3*A4*V1*V2^3/4):RETURN
1040  G=(3*A3*V2*V1^2/4)+(3*A5*V2*V1^4/4)+(3*A5*V1^2*V2^3/4):RETURN
1050  G=(3*A3*V1*V2^2/4)+(3*A5*V1*V2^4/4)+(3*A5*V2^2*V1^3/4):RETURN
1060  G=A4*V2*V1^3/4:RETURN
1070  G=A4*V1*V2^3/4:RETURN
1080  G=A4*V1^2*V2^2/4:RETURN
1090  G=A5*V2^2*V3^3/4:RETURN
1100  G=A5*V1^2*V2^3/4:RETURN
1110  G=3*A5*V2*V1^4/16:RETURN
1120  G=3*A5*V1*V2^4/16:RETURN
1130  REM DELAY ROUTINE
1140  FOR I=1 TO 5000:NEXT I
1150  RETURN
1160  REM ROUTINE FOR HARDCOPY/SCREEN DISPLAY SWITCH FO SAME DATA
1170  INPUT "Do you want Hard Copy ";DV$
1180  DV=0
1190  IF LEFT$(DV$,1)="Y" OR LEFT$(DV$,1)="y"THEN DV=2
1200  GOTO 490
2000  INPUT "Is this an 80 column or a 132 column printer";W
2010  OPTION #2,"W",W
2020  PRINT#2,CHR$(12)
2030  LIST#2
