10  CLS: PRINT "PROGRAM TO CALC REFLECTION COEF <> Z"
15  PRINT "BY A. KATZ FOR TSC ELECTRONICS PROGRAM V2.1 (8/18/86)
20  REM: RECT. TO POLAR FIXED AND IMPROVED FORMAT - GH 6/15/86
30  REM: MODIFIED FOR IBM PC BY ART HOLMES
40  REM PRECISION 5: REM BY A. KATZ V2.0 12/22/83
50  PI=4*ATN(1)
60  REM COMPLEX ARITHMATIC SUBROUTEENS
70  DG=180/PI: Z0=50
80  DEF FNMR(AR,AX,BR,BX)=AR*BR-AX*BX
90  DEF FNMX(AR,AX,BR,BX)=AR*BX+AX*BR
100  DEF FNDR(AR,AX,BR,BX)=(AR*BR+AX*BX)/(BR^2+BX^2)
110  DEF FNDX(AR,AX,BR,BX)=(AX*BR-AR*BX)/(BR^2+BX^2)
120  DEF FNMG(AR,AX)=SQR(AR^2+AX^2)
130  DEF FNAG(AR,AX)=DG*(ATN(AX/AR)-(SGN(AR)-1)*PI/2)
140  DEF FNR(MG,AG)=MG*COS(AG/DG)
150  DEF FNX(MG,AG)=MG*SIN(AG/DG)
170  PRINT: INPUT "WANT TO CALC Z OR REF COEF (Z/R) OR (END)"; Q$
175  IF Q$="END" THEN END
180  IF Q$="R" THEN 300 ELSE IF Q$<>"Z" THEN 170
190  REM:******calculate z from ref. coef.************************
200  PRINT: INPUT "MAG OF REF COEF (IF NEG THEN IN dB)"; MI
210  INPUT "ANGLE"; AG: IF MI<0 THEN MG=10^(MI/20) ELSE MG=MI
220  RG=FNR(MG,AG): XG=FNX(MG,AG)
230  IF RG=1 THEN RG=1.0001
240  RZ=Z0*FNDR(1+RG,XG,1-RG,-XG): XZ=Z0*FNDX(1+RG,XG,1-RG,-XG)
250  PRINT: PRINT, "REF COEF MAG =" MG " AT ANGLE" AG "
260  PRINT "Z IN RECT. FORM :       REAL = ";RZ;:PRINT "      IMAG = ";XZ
270  PRINT: INPUT "WANT HARD COPY (Y/N)"; H$
280  IF H$="Y" GOTO 440 ELSE GOTO 170
290  REM:******calculate ref. coef from z*************************
300  PRINT: INPUT "REAL PART OF IMPEDANCE"; RZ
310  INPUT "IMAGINARY PART OF IMPEDANCE"; XZ
320  RG=FNDR(RZ-Z0,XZ,RZ+Z0,XZ)
330  XG=FNDX(RZ-Z0,XZ,RZ+Z0,XZ)
340  IF RG=0 THEN RG=9.9999E-05
350  REM: IF XG=0 THEN XG=.0001
360  GM=FNMG(RG,XG): GA=FNAG(RG,XG): PRINT
370  PRINT: PRINT, "REAL Z =" RZ " IMAG Z =" XZ "
380  PRINT "REFLECTION COEFFICIENT:"
390  PRINT "     RECTANGULAR FORM:  REAL = ";RG;: PRINT "  IMAG. = ";XG
400  PRINT "     POLAR FORM      :  MAG. = ";GM;: PRINT "  ANG.  = ";GA
402  DB=20*LOG(GM)/LOG(10)
405  PRINT " RETN LOSS FORM      :  M dB = ";DB;: PRINT "  ANG.  = ";GA
410  PRINT: INPUT "WANT HARD COPY (Y/N)"; H$
420  IF H$="Y" GOTO  470  ELSE GOTO 170
430   REM: **********************PRINT ROUTINE*********************
440  LPRINT, "REF COEF MAG =" MG " AT ANGLE" AG "
450  LPRINT "Z IN RECT. FORM :       REAL = ";RZ;:LPRINT "      IMAG = ";XZ
460  GOTO 170
470  LPRINT: LPRINT, "REAL Z =" RZ " IMAG Z =" XZ "
480  LPRINT "REFLECTION COEFFICIENT:"
490  LPRINT "     RECTANGULAR FORM:  REAL = ";RG;:LPRINT "  IMAG. = ";XG
500  LPRINT "     POLAR FORM      :  MAG. = ";GM;:LPRINT "  ANG.  = ";GA
505  LPRINT " RETN LOSS FORM      :  M dB = ";DB;: PRINT "  ANG.  = ";GA
510  GOTO 170
520  END
